#ifndef __EDIT_H__
#define __EDIT_H__

#define APP_SHORT_TITLE            "AkelPad"
#define APP_ABOUT_VERSION          "AkelPad 3.0.0 alpha 5"
#define APP_HOMEPAGE               "http://akelpad.net.ru"
#define APP_ABOUT_EMAIL_KUZNETSOV  "developer@akelpad.net.ru"
#define APP_ABOUT_ICQ_KUZNETSOV    "109590531"
#define APP_ABOUT_EMAIL_SHENGALTS  "shengalts@mail.ru"

#ifndef IMF_AUTOFONTSIZEADJUST
  #define IMF_AUTOFONTSIZEADJUST 0x0010
#endif
#ifndef GT_SELECTION
  #define GT_SELECTION 0x00000002
#endif
#ifndef PFN_ARABIC
  #define PFN_ARABIC 2
#endif
#ifndef PFN_UCLETTER
  #define PFN_UCLETTER 4
#endif
#ifndef PFN_UCROMAN
  #define PFN_UCROMAN 6
#endif
#ifndef PFNS_PAREN
  #define PFNS_PAREN 0x000
#endif

#define TRANSLATE_BUFFER_SIZE     8192
#define DETECTBINARY              128
#define TEMP_BUFFER_SIZE          1024
#define ARRAY_SIZE                128
#define RECENTFILES               10
#define RECENTFILES_RECORD_LENGTH 90

//Code pages
#define KOI8_R              20866
#define CP_UNICODE_UCS2_LE -17
#define CP_UNICODE_UCS2_BE -18
#define CP_UNICODE_UTF8    -19

//Search/Replace options
#define FR_UP           0x00000008
#define FR_BEGINNING    0x00000010
#define FR_SELECTION    0x00000020
#define FR_ESCAPESEQ    0x00000040

//Selection case
#define UPPERCASE    1
#define LOWERCASE    2
#define SENTENCECASE 3
#define TITLECASE    4
#define INVERTCASE   5

//Insert/Delete char in selection
#define CHECK_STATE                 1
#define CHAR_INSERT                 2
#define CHAR_DELETE                 3

//Delete trailing whitespaces in selection
#define CHECK_TRAILING_WHITESPACES  1
#define DELETE_TRAILING_WHITESPACES 2

//Change font size
#define DECREASE_FONT 1
#define INCREASE_FONT 2

void InitEditor(HWND);

BOOL DoFileNew(HWND hWndEdit);
void DoFileNewWindow(HWND hWndEdit);
BOOL DoFileOpen(HWND hWndEdit);
void DoFileReopen(HWND hWndEdit);
BOOL DoFileSave(HWND hWndEdit);
BOOL DoFileSaveAs(HWND hWndEdit);
void DoFilePageSetup(HWND hWndEdit);
void DoFilePrint(HWND hWndEdit);
BOOL DoFileExit(HWND hWndEdit);
void DoEditUndo(HWND hWndEdit);
void DoEditRedo(HWND hWndEdit);
void DoEditCut(HWND hWndEdit);
void DoEditCopy(HWND hWndEdit);
void DoEditPaste(HWND hWndEdit);
void DoEditClear(HWND hWndEdit);
void DoEditSelectAll(HWND hWndEdit);
void DoEditInsertChar(HWND hWndEdit);
BOOL DoEditInsertCharInSelection(HWND hWndEdit, int nAction, char ch);
BOOL DoEditDeleteTrailingWhitespaces(HWND hWndEdit, int nAction);
void DoEditChangeCase(HWND hWndEdit, int nCase);
void DoSearchFind(HWND hWndEdit);
void DoSearchFindNextDown(HWND hWndEdit);
void DoSearchFindNextUp(HWND hWndEdit);
void DoSearchReplace(HWND hWndEdit);
void DoSearchGoToLine(HWND hWndEdit);
void DoViewFont(HWND hWndEdit);
void DoViewBG(HWND hWndEdit);
void DoViewFontSize(HWND hWndEdit, int nAction);
void DoViewAlignment(HWND hWndEdit, WORD wAlignment);
void DoViewNumbering(HWND hWndEdit, WORD wNumbering);
void DoViewOnTop(HWND hWndEdit, BOOL bBool);
void DoViewWrap(HWND hWndEdit, BOOL bBool);
void DoViewShowStatusBar(HWND hWndEdit, BOOL bBool);
void DoSettingsSaveTime(HWND hWndEdit, BOOL bBool);
void DoSettingsMultiOpen(HWND hWndEdit, BOOL bBool);
void DoSettingsKeepSpace(HWND hWndEdit, BOOL bBool);
BOOL DoCodePageOpenAs(HWND hWndEdit, int nCP);
BOOL DoCodePageSaveIn(HWND hWndEdit, int nCP);
void DoHelpAbout(HWND hWndEdit);
void DoNonMenuDelLine(HWND hWndEdit);

BOOL RestorePreOptionsFromRegistry();
BOOL RestoreOptionsFromRegistry(HWND hWndEdit);
BOOL SaveOptionsInRegistry(HWND hWnd);

BOOL OpenDocument(HWND hWndEdit, char *szFile, BOOL bAutodetect);
DWORD CALLBACK InputStreamCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
DWORD CALLBACK InputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);

BOOL SaveDocument(HWND hWndEdit, char *szFile);
DWORD CALLBACK OutputStreamCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
DWORD CALLBACK OutputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);

int SelectCodePage(HWND hWndEdit);
BOOL CALLBACK SelectDlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK EnumCodePagesProc(LPTSTR lpCodePageString);
BOOL DisplayCodePage(int cp);
void AutodetectCodePage(unsigned char *ubuf, int len);
unsigned int UTF8toUTF16(const char *buf, unsigned int *len, wchar_t *tbuf, unsigned int tlen);
unsigned int UTF16toUTF8(const wchar_t *tbuf, unsigned int tlen, char *buf, unsigned int len);
void ChangeByteOrder(unsigned char *buf, unsigned int len);
int getmaxelement(int *base,int iCount);
unsigned int TranslateNewLinesToUnixA(char *buf, unsigned int *len);
unsigned int TranslateNewLinesToUnixW(wchar_t *tbuf, unsigned int *tlen);

BOOL CALLBACK FindAndReplaceDlgProcA(HWND hDlg,UINT msg,WPARAM wParam,LPARAM lParam);
BOOL CALLBACK FindAndReplaceDlgProcW(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
int FindTextA(HWND hWndEdit);
int FindTextW(HWND hWndEdit);
int ReplaceTextA(HWND hWndEdit, BOOL all);
int ReplaceTextW(HWND hWndEdit, BOOL all);
BOOL TranslateEscapeSequenceA(HWND hDlg, char *input, char *output);
BOOL TranslateEscapeSequenceW(HWND hDlg, wchar_t *input, wchar_t *output);

void ReplaceSelA(HWND hWndEdit, char *pData);
void ReplaceSelW(HWND hWndEdit, wchar_t *pData);
DWORD CALLBACK ReplaceSelCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
DWORD CALLBACK ReplaceSelCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);

BOOL CALLBACK GoToLineDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

void RecentFilesRead();
BOOL RecentFilesUpdate(char *file, int position);
int RecentFilesDeleteDead();
void RecentFilesSave();
void RecentFilesMenu(HWND hWndEdit);
int TrimPath(char *szResult, char *pPath, int nMax);

void LanguageMenu(HWND hWndEdit);
char* GetBaseName(char *pFile, char *szBaseName);

BOOL isInDelimiterList(wchar_t c);
int CALLBACK MyEditWordBreakProc(LPTSTR pchText, int ichCurrent, int cch, int code);

BOOL CALLBACK AboutDlgProc(HWND hDlg,UINT msg,WPARAM wParam,LPARAM lParam);

BOOL SaveChanged(HWND hWndEdit);
void SetChosenFont(HWND hWndEdit);
int SetLayout();
void RestoreLayout(int reserv_layout);
BOOL GetModify();
void SetModify(BOOL state);
BOOL FileExists(char *fname);
void FreeMemory();

HMENU API_LoadMenu(HINSTANCE hLoadInstance, LPCTSTR lpMenuName);
HACCEL API_LoadAccelerators(HINSTANCE hLoadInstance, LPCTSTR lpTableName);
HCURSOR API_LoadCursor(HINSTANCE hLoadInstance, LPCTSTR lpCursorName);
HICON API_LoadIcon(HINSTANCE hLoadInstance, LPCTSTR lpIconName);
int API_LoadString(HINSTANCE hLoadInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax);
HWND API_CreateDialogParamA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam);
HWND API_CreateDialogParamW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam);
LPVOID API_HeapAlloc(HANDLE hHeap, DWORD dwFlags, SIZE_T dwBytes);


#endif
